-- frmSettings.lua
-- written by Habna

--v IMPORT SECTION v--

--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
InitXPos, InitYPos = 17,33; --> ** Initial X & Y position of the first Item in the HugeBag **
edgePadding = 15; --> ** HugeBag initial edgePadding value **
Version = "1.0.4"; --> ** HugeBag current version **
StartVisible = true; --> ** Initial value to determine if HugeBag start visible or not **
ShowSlotsInfo = true; --> ** Initial value to determine if slots informations are shown are not in title **
ToggleUsed = false; --> ** Initial value to determine if free slots info are shown in title if true used slots info will be shown **
WinWidth, WinHeight = 460,300; --> ** HugeBag initial size **
WinLocX, WinLocY = self, self; --> ** HugeBag initial location **
LockPosition, LockSize = false, false; --> ** Initial value to determine if position and size are lock by default
LockLabel = self; --> ** Label that prevents from moving the window cause it's located at top
HideWEsc = false; --> ** Initial value to determine if HugeBag hide when 'esc' key is press **
DefaultOpacity = 1; --> ** Initial opacity **
write = Turbine.Shell.WriteLine;
--^ GLOBAL VARIABLE SECTION ^--

function frmSettings()
	--v SETTINGS SECTION v--
	green = Turbine.UI.Color( 0, 0.77, 0 );
	white = Turbine.UI.Color( 1, 1, 1 );

	self = Turbine.UI.Lotro.Window()
	--self = Turbine.UI.Lotro.GoldWindow()
		
	--^ SETTINGS SECTION ^--
	--v EVENT HANDLERS SECTION v--
	--**v Window event handlers v**
	-- **v Set the opacity when the mouse enter the window v**
	self.MouseEnter = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	self.MouseLeave = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Do stuff before closing the window v**
	self.Closing = function( sender, args )
		
	end
	-- **^
	-- **v Position changed event v**
	self.PositionChanged = function(args)
		
	end
	-- **^
	-- **v Detecting key press event v**
	self.KeyDown = function( sender, args )
	
	end
	-- **^
	-- **v Windows mouse down event v**
	self.MouseDown = function( sender, args )
		
	end
	-- **^
	-- **v Windows mouse up event v**
	self.MouseUp = function( sender, args )
		
	end
	-- **^
	-- **v Windows mouse move event v**
	self.MouseMove = function( sender, args )
		
	end
	-- **^
	-- **v Windows sizechanged event v**
	self.SizeChanged = function( sender, args )
		
	end
	-- **^
	--**^ Window event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^
--v FUNCTIONS/METHODS SECTION v--
-- **v Load settings v**
function LoadSettings( sender )
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagSettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		WinLocX = Turbine.UI.Display.GetWidth() - edgePadding - WinWidth
		WinLocY = Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55
		SaveSettings()
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.X;
	WinLocY = settings.Y;
	WinWidth = settings.Width;
	WinHeight = settings.Height;
	HideWEsc = settings.HideWEsc;
	StartVisible = settings.StartVisible;
	ShowSlotsInfo = settings.ShowSlotsInfo;
	ToggleUsed = settings.ToggleUsed;
	LockPosition = settings.LockPosition;
	LockSize = settings.LockSize;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		local Updatedsettings = {};

		if settings.StartVisible == nil then
			Updatedsettings.StartVisible = true;
		else
			Updatedsettings.StartVisible = StartVisible;
		end
		if settings.ShowSlotsInfo == nil then
			Updatedsettings.ShowSlotsInfo = true;
		else
			Updatedsettings.ShowSlotsInfo = ShowSlotsInfo;
		end

		Updatedsettings.X = WinLocX;
		Updatedsettings.Y = WinLocY;
		Updatedsettings.Width = WinWidth;
		Updatedsettings.Height = WinHeight;

		if settings.HideWEsc == nil then
			Updatedsettings.HideWEsc = false;
		else
			Updatedsettings.HideWEsc = HideWEsc;
		end
		if settings.LockPosition == nil then
			Updatedsettings.LockPosition = false;
		else
			Updatedsettings.LockPosition = LockPosition;
		end
		if settings.LockSize == nil then
			Updatedsettings.LockSize = false;
		else
			Updatedsettings.LockSize = LockSize;
		end
		if settings.ToggleUsed == nil then
			Updatedsettings.ToggleUsed = false;
		else
			Updatedsettings.ToggleUsed = ToggleUsed;
		end

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.X = WinLocX; --Turbine.UI.Display.GetWidth() - edgePadding - self:GetWidth()
	settings.Y = WinLocY; --Turbine.UI.Display.GetHeight() - edgePadding - self:GetHeight() - 55
	settings.Width = WinWidth; --frmMain:GetWidth();
	settings.Height = WinHeight; --frmMain:GetHeight();
	settings.StartVisible = StartVisible;
	settings.ShowSlotsInfo = ShowSlotsInfo;
	settings.ToggleUsed = ToggleUsed;
	settings.HideWEsc = HideWEsc;
	settings.LockPosition = LockPosition;
	settings.LockSize = LockSize;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", settings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = true;
	ShowSlotsInfo = true;
	ToggleUsed = false;
	HideWEsc = false;
	LockPosition = false;
	LockSize = false;
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--